/*
 * P4.Net *
Copyright (c) 2007 Shawn Hladky

Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
and associated documentation files (the "Software"), to deal in the Software without 
restriction, including without limitation the rights to use, copy, modify, merge, publish, 
distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the 
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or 
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */


#pragma once

#using <mscorlib.dll>
#include "StdAfx.h"
#include <vcclr.h>


namespace p4dn {

	__gc public class P4String
    {

    public:
		P4String(System::String* str, System::Text::Encoding* encoding);

		System::String* ToManagedString(System::Text::Encoding* encoding);

    private:          
        System::Byte _bytes[];

	public private:
		
		static System::String* StrPtrToString(StrPtr* buffer, System::Text::Encoding* encoding)
		{
			return new System::String(buffer->Text(), 0, buffer->Length(), encoding);
		}
		static System::String* CharArrToString(const char* buffer, System::Text::Encoding* encoding)
		{
			return new System::String(buffer, 0, strlen(buffer), encoding);
		}

		static System::String* ErrorToString(Error* e, System::Text::Encoding* encoding)
		{
			StrBuf err;
			e->Fmt(&err);
			System::String* errMsg = StrPtrToString(&err, encoding);
			return errMsg;
		}

		static void StringToStrBuf(StrBuf* buffer, System::String* str, System::Text::Encoding* encoding)
		{
			if(str->Length > 0)
			{
				System::Byte b[]  = encoding->GetBytes(str);
				unsigned char __pin* ptr = &(b[0]);
				buffer->Set((const char*)ptr);
				//buffer->Terminate();
			}
			else
			{
				buffer->Set("");
				//buffer->Terminate();
			}
		}
		P4String(::StrPtr* str);
		void SetStrBuf(::StrBuf* str);
		
    };

} // end namespace




